"""
Generelt om sensorveiledning og løsningsforslag:

Ved siden av de poeng som oppgis her, står sensor også fritt til å
gjøre skjønnsmessige vurderinger. Dersom mange elementer er på plass, mens
prinsipper som er vektlagt i undervisning (inkludert objektorientering) mangler,
skal det trekkes for dette. Som eksempel skal non-public instansvariabler (eller
-metoder) ikke aksesseres utenfra klassen, definerte metoder skal brukes
der de fyller etterspurt funksjonalitet og instansvariabler skal ikke endres
som en bieffekt av metoder (som for eksempel absoluttDato). 
"""

### OPPGAVE A (2p) ###

# Opprettelse av klasse + hentBrukernavn: 1p
# Konstruktør: 1p
class Student:

    def __init__(self, brukernavn):
        self._brukernavn = brukernavn
        self._emner = []                # Brukes ikke, kan utelates

    def hentBrukernavn(self):
        return self._brukernavn

### OPPGAVE A SLUTT ###


### OPPGAVE B (4p) ###

# Klasse opprettet: 1p
# Konstruktør oppretter tom liste: 2p
# leggTilAktivitet korrekt: 1p

class Emne:

    def __init__(self, emnekode):
        self._emnekode = emnekode
        self._aktiviteter = []

    def leggTilAktivitet(self, aktivitet):
        self._aktiviteter.append(aktivitet)

### OPPGAVE B SLUTT ###

### HJELPEMETODER: ###

    def hentAktivitet(self, aktDato):
        for akt in self._aktiviteter:
            if akt.absoluttDato() == aktDato:
                return akt
        return None
    
    def hentAktivitetMedNavn(self, navn):
        for akt in self._aktiviteter:
            if akt.hentBrukernavn() == navn:
                return akt

    def alleAktiviteter(self):
        return self._aktiviteter

    def hentEmnekode(self):
        return self._emnekode


### OPPGAVE C (12p) ###

# Klasse og konstruktør: 2p
# AbsoluttDato:
    # returnerer alltid 5 (hvis år 01-09) eller 6 siffer: 6p
    # returnerer riktig rekkefølge, ikke seks siffer: 3p
# __str__: bygger opp fornuftig streng og:
    # returnerer strengen: 4p
    # skriver ut strengen med print: 1p
# Helhetsvurdering for poenggiving på tvers av metodene. OBS typer

# Obs: absoluttDato() her for oppgavesett 1. Om de har fått oppgavesett 2
# skal de konkatenere i endret rekkefølge. Det er en feil for dette settet
# der oppgaveteksten krever formen MMDDÅÅ, mens eksempelet viser
# MMÅÅDD. Begge deler er akseptert og gir full uttelling i sett 2.


class Dato:

    def __init__(self, dag, maaned, aar):
        self._dag = dag
        self._maaned = maaned
        self._aar = aar


    def absoluttDato(self):         # Variant 1
        absDato = self._aar * 10000 + self._maaned * 100 + self._dag
        return absDato

#       aDato = self._maaned * 10000 + self._dag * 100 + self._aar  For oppgavesett 4.2



#    def absoluttDato(self):          # Variant 2
#        dagStr = str(self._dag)
#        if len(dagStr) < 2:
#            dagStr = "0" + dagStr
#        maanedStr = str(self._maaned)
#        if len(maanedStr) < 2:
#            maanedStr = "0" + maanedStr
#        aarStr = str(self._aar)
#        if len(aarStr) < 2:
#            aarStr = "0" + aarStr
#        datoStr = aarStr + maanedStr + dagStr
#        dato = int(datoStr)         
#        return dato


    def __str__(self):
        dato_str = str(self._dag) + ". "
        if self._maaned == 9:
            dato_str += "september"
        elif self._maaned == 10:
            dato_str += "oktober"
        elif self._maaned == 11:
            dato_str += "november"
        elif self._maaned == 12:
            dato_str += "desember"
        else:
            dato_str += "ukjent"                # Ikke et krav
        if self._aar < 10:
            dato_str += " 200" + str(self._aar)
        else:
            dato_str += " 20" + str(self._aar)
        return dato_str
    

### OPPGAVE C SLUTT ###


### OPPGAVE D (12p) ###

# Klasse og konstruktør m/param: 2p
# Konstruktør oppretter tomme lister: 2p
# leggTil..(), registrer..(), oppmote() korrekt: 2p
# absoluttDato henter verdi fra dato-objekt: 4p (ellers 0p)
# __str__ returnerer fornuftig streng: 2p (ved printing og ikke retur 0p)
# Helhetsvurdering for poenggiving på tvers av metodene. OBS typer

class Aktivitet:

    def __init__(self, emne, dato, gruppenr):
        self._emne = emne
        self._dato = dato
        self._gruppenr = gruppenr
        self._regstud = []
        self._oppmott = []

    def leggTilRegistrertStudent(self, stud):
        self._regstud.append(stud)

    def registrerOppmote(self, stud):
        self._oppmott.append(stud)

    def skrivUtOppmotteStudenter(self):
        for stud in self._oppmott:
            print(stud.hentBrukernavn())

    def absoluttDato(self):
        return self._dato.absoluttDato()

    def oppmote(self):
        return len(self._oppmott)

    def __str__(self):
        return "Emne " + self._emne.hentEmnekode() + " aktivitet "+ self._gruppenr + \
        " oppmotte: "+ str(self.oppmote())

### OPPGAVE D SLUTT ###

### HJELPEMETODER ###

    def hentBrukernavn(self):
        return self._gruppenr

from emne import Emne
from dato import Dato
from aktivitet import Aktivitet
from student import Student

### OPPGAVE E (3p) ###

# Oppretter klasse samt tomme ordbøker i konstruktør: 3p

class Undervisningsadministrasjon:

    def __init__(self):
        self._emner = {}
        self._datoer = {}
        self._studenter = {}                # Brukes ikke, kan utelates

### OPPGAVE E SLUTT ###

### OPPGAVE F (10p) ###

# Leser fil linje for linje: 1p
# Korrekt parsing med .split(): 1p
# Emnekode:
    # Ingen duplikater av emner (samme emne, samme objekt): 3p
# Dato:
    # Ingen duplikater, legger inn ny dato hvis ikke finnes: 4p
# Legger inn aktivitetsobjekt på riktig emne (oppslag ordbok): 1p

    def lesEmneAktiviteter(self, filnavn):
        fil = open(filnavn)
        for linje in fil:
            data = linje.split()
            emnekode = data[0]
            akt = data[1]
            aar = data[2]
            mnd = data[3]
            dag = data[4]
            absDatoStr = aar + mnd + dag
            if emnekode not in self._emner:
                self._emner[emnekode] = Emne(emnekode)
            if absDatoStr not in self._datoer:
                self._datoer[absDatoStr] = Dato(dag, mnd, aar)
            aktivitet = Aktivitet(self._emner[emnekode], self._datoer[absDatoStr], akt)
            self._emner[emnekode].leggTilAktivitet(aktivitet)

### OPPGAVE F SLUTT ###

### OPPGAVE G (7p) ###

# Innlesing av fil linje for linje: 1p
# Oppretter studentobjekt: 1p
# Henter riktig emne og aktivitet, registrerer student på aktiviteten: 5p

    def lesStudentFil(self, filnavn):
        fil = open(filnavn)
        for linje in fil:
            data = linje.split()
            stud = Student(data[0])
            emne = data[1]
            akt = data[2]
            self._emner[emne].hentAktivitetMedNavn(akt).leggTilRegistrertStudent(stud)

### OPPGAVE G SLUTT ###

### OPPGAVE H (5p) ###

# Går gjennom alle verdier i ordboka: 1p
# Går gjennom alle aktiviteter for gjeldende emne: 2p
# Korrekt sjekk på antall mot oppmøtte: 2p

# Obs: dette er for oppgavesett 1. For oppgavesett 2 er if-sjekken snudd
# og metodenavnet skal være "[..]hoytOppmoete()"

    def skrivGrupperMedLavtOppmoete(self, antall):
        for e in self._emner.values():
            for akt in e.alleAktiviteter():
                if akt.oppmote() < antall:
                    print(akt)

### OPPGAVE H SLUTT ###
